<?php

namespace AppBundle\Repository\Content;

use AppBundle\Entity\Content\Proposal;
use AppBundle\Entity\Group\Group;

/**
 * ProposalRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class ProposalRepository extends \Doctrine\ORM\EntityRepository
{
    public function queryProposals(Group $group = null)
    {
        $qb = $this->createQueryBuilder('p');
        if($group) {
            $qb->leftJoin('p.referedGroups', 'g');
        }
        $qb->where('p.status = :status')
            ->setParameter('status', Proposal::STATUS_OPEN);
        if($group) {
            $qb->andWhere('g.id = :group')
                ->setParameter('group', $group->getId());
        }
        $qb->orderBy('p.NComments', 'DESC');
        $qb->addOrderBy('p.createdAt', 'DESC');

        return $qb;
    }

    protected function findProposals_($filters)
    {
        $qb =  $this->createQueryBuilder('p')
            ->where('p.status = :status')
            ->setParameter('status', Proposal::STATUS_OPEN)
            ->orderBy('p.createdAt', 'DESC');

        if (isset($filters['title'])){
            $qb->andWhere('p.title like :title')
                ->setParameter('title', '%'.$filters['title'].'%');
        }

        if (isset($filters['group'])){
        $qb->leftJoin('p.referedGroups', 'g');
            $qb->andWhere('g.id = :group')
                ->setParameter('group', $filters['group']);
        }


        return $qb;
    }

    public function findProposals($filters, $votation = null)
    {
        $qb = $this->findProposals($filters);
        if($votation) {
            $now = new Date();
            if($votation->getEndDate() < $now) {
                $qb->orderBy("s.weight", "DESC");
            }
        }
        return $qb;
    }

    public function findVotation($filters)
    {
        $qb = $this->findProposals_($filters);
        $res = $qb->getQuery()->getResult();
        if(count($res) > 0) {
            $proposal = $res['0'];
            if(count($proposal->getSupervisedVotations())) {
                return $proposal->getSupervisedVotations()->first();
            }
        }
        return null;
    }

    public function findProposal($project, $number)
    {
        $proposal = null;
        $qb = $this->createQueryBuilder('p');
        $qb->leftJoin('p.section', 'ss');
        $qb->leftJoin('ss.section', 's');
        $qb->andWhere('s.project = :project')
        ->setParameter('project', $project);
        $qb->andWhere('p.number = :number')
            ->setParameter('number', $number);
        $res = $qb->getQuery()->getResult();
        if(count($res) > 0) {
            $proposal = $res['0'];
        }
        return $proposal;
    }
}
